// PCIWDGDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PCIWDG.h"
#include "PWDGDlg.h"
#include "AIOWDM.h"



bool Testing;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CPCIWDGDlg dialog

CPCIWDGDlg::CPCIWDGDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPCIWDGDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPCIWDGDlg)
	m_StatusLabel = _T("Watchdog Status");
	m_LoopLabel = _T("");
	m_BaseAddress = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPCIWDGDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPCIWDGDlg)
	DDX_Control(pDX, IDOK, m_TestButton);
	DDX_Text(pDX, IDC_STATUSLABEL, m_StatusLabel);
	DDX_Text(pDX, IDC_LOOPLABEL, m_LoopLabel);
	DDX_Text(pDX, IDC_BASEEDIT, m_BaseAddress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPCIWDGDlg, CDialog)
	//{{AFX_MSG_MAP(CPCIWDGDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SHOWWINDOW()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDCANCEL, OnExitButton)
	ON_BN_CLICKED(IDOK, OnTestButton)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPCIWDGDlg message handlers

BOOL CPCIWDGDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   if (InPortB(0x61) == 0xAA55) {
      MessageBox("ACCESNT.SYS not detected. Please copy ACCESNT.SYS into [NT]/system32/drivers and re-run this sample.", "Warning", MB_OK);
   }

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPCIWDGDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPCIWDGDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPCIWDGDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	FindCards();	
}

void CPCIWDGDlg::FindCards(void)
{
	bool found;
	DWORD num, i, DeviceID;

	found = false;

	num = GetNumCards();

	for (i=0; i<num; i++)
	{
		if ( ! QueryCardInfo(i, &DeviceID, &BaseAddr, NULL, NULL) ) continue;
		if ( DeviceID != 0x22C0 ) continue;

		char text[64];
		sprintf(text, "%4.4x", BaseAddr);
		m_BaseAddress = text;
		found = true;
		break;
	}
	if ( ! found )
	{
		m_BaseAddress = "300";
	}
	UpdateData(false);
}

void CPCIWDGDlg::OnClose() 
{
	InPortB(BaseAddr + 6);
	InPortB(BaseAddr + 7);
	
	CDialog::OnClose();
}

void CPCIWDGDlg::OnExitButton() 
{
	OnClose();

	exit(0);	
}

void CPCIWDGDlg::CtrMode(unsigned char cntr, unsigned char mode)
{
	OutPortB(BaseAddr+3, (cntr << 6) | 0x30 | (mode << 1));
}

void CPCIWDGDlg::LoadCtr(unsigned char c, unsigned short val)
{
	OutPortB(BaseAddr+c, val & 0xFF);
	OutPortB(BaseAddr+c, (val>>8) & 0xFF);
}

void CPCIWDGDlg::SetCounter()
{
	InPortB(BaseAddr+7); // disable counter functions
	CtrMode(2,0);           // set counter 2 to mode 0
	OutPortB(BaseAddr+7,0); // enable counters
	InPortB(BaseAddr+7); // disable counter functions
	OutPortB(BaseAddr+6,0);  // enable buzzer
	OutPortB(BaseAddr+0x0C,0); // select low clock rate
	InPortB(BaseAddr+0x0D); // disable opto reset
	InPortB(BaseAddr+0x0E); // disable opto reset
	InPortB(BaseAddr+0x0F); // disable program outputs
	// program the counters for the REQUIRED modes
	CtrMode(0,3); // set counter 0 to mode 3
	LoadCtr(0,0xFFFF);        // full load value
	CtrMode(1,2); // set counter 1 to mode 2
	LoadCtr(1,0x10); // load counter 1 with 10 hex
	CtrMode(2,1); // set counter 2 to mode 1
	// Note:Not loading counter 2 creates an infinite reset duration
	// Set the reset duration by loading a value in counter 2
	// Change counter 2 to mode 2 to set duration
}

void CPCIWDGDlg::OnTestButton() 
{
	if (!Testing)
	{
		UpdateData(true);
		sscanf(m_BaseAddress, "%lx", &BaseAddr);

		SetCounter();

		m_TestButton.SetWindowText("&Abort");
		m_StatusLabel = " Watchdog Okay";
		Testing = true;
		State = Loop = 0;
		SetTimer(0, 35, NULL);

	}
	else
	{
		InPortB(BaseAddr + 6);
		InPortB(BaseAddr + 7);
		KillTimer(0);
		m_TestButton.SetWindowText("&Test");
		State = Loop = 0;
		Testing = false;
	}
	UpdateData(false);
}

void CPCIWDGDlg::OnTimer(UINT nIDEvent) 
{
	unsigned short readback;

	switch(State)
	{
		case 0:
			InPortB(BaseAddr+4); // clear any pending interrupts
			OutPortB(BaseAddr+7,0); // start counters counting
			State++;
			break;

		case 1:
			CtrMode(1,2);
			LoadCtr(1,0x10); // keep reloading counter
			if (++Loop == 100)
				State++;
			char text[64];
			sprintf(text, " Updating counter 1 ... loop number: %3.3d", Loop);
			m_LoopLabel = text;
			break;

		case 2:
			readback = InPortB(BaseAddr+4);
			if ((readback & 0x01) == 0)
			{
				m_StatusLabel = " Watchdog Timed Out";
				m_TestButton.SetWindowText("&Test");
				Testing = false;
				State++;
				Loop = 0;
			}
			else
				m_StatusLabel = " Waiting for Timeout";
			break;

		case 3:
			Loop++;
			if (Loop == 5)
			{
				InPortB(BaseAddr + 6);
				KillTimer(0);
				State = Loop = 0;
			}
			break;
	}
	UpdateData(false);
	
	CDialog::OnTimer(nIDEvent);
}
